package fr.insarouen.asi.document.quizz.webSemantique.Wikidata;

import fr.insarouen.asi.document.quizz.QuestionReponses;
import fr.insarouen.asi.document.quizz.Aleatoire;
import java.net.URL;
import java.net.MalformedURLException;
import org.apache.jena.query.QuerySolution;
import org.apache.jena.rdf.model.RDFNode;
import java.util.ArrayList;
import java.util.List;
import fr.insarouen.asi.document.quizz.webSemantique.Outils;

public  class QuestionReponsesCapitales extends QuestionReponsesWikidata  {  

    String uriPays;


    private static String getURICapitale(String uriPays) {
	String res = "";
	RDFNode rdfName;
	String request = "select ?uri where{<"+uriPays+"> wdt:P36 ?uri}";
        for (QuerySolution solution : Outils.SPARQLQuerySolutions(getEntreeSparql(), getPrefixSparql(), request)) {
            rdfName = solution.get("uri");
            res = rdfName.toString();
        }
	return res;
    }

    private static List<String> getURIAutresCapitales(String uriPays) {
	List<String> res = new ArrayList<String>();
	RDFNode rdfName;
	String request = "select distinct ?capitalePays  where{\n";
	request = request + "<"+uriPays+"> wdt:P36 ?capitale.\n";
	request = request + "?pays wdt:P36 ?capitalePays.\n";
	request = request + "?pays wdt:P31 wd:Q6256.\n";
	request = request + "filter (?pays != <"+uriPays+"> && isiri(?capitalePays))}\n";
        for (QuerySolution solution : Outils.SPARQLQuerySolutions(getEntreeSparql(), getPrefixSparql(), request)) {
            rdfName = solution.get("?capitalePays");
            res.add(rdfName.toString());
        }
	return res;
    }

    private static List<String> choisirCapitales(List<String> ls, int nb) {
	int pos;
	List<String> res = new ArrayList<String>();
	for(int i=0;i<nb;i++) {
	    pos = Aleatoire.entierAleatoire(0, ls.size());
	    res.add(ls.remove(pos));
	}
	return res;
    }

    private static String getNomCapitaleOuPays(String uri) {
	String res = "";
	RDFNode rdfName;
	String request = "select ?nom where{<"+uri+">  rdfs:label ?nom.";
	request = request+"filter(langmatches(lang(?nom), 'fr'))}";
        for (QuerySolution solution : Outils.SPARQLQuerySolutions(getEntreeSparql(), getPrefixSparql(), request)) {
            rdfName = solution.get("nom");
            res = langStringToString(rdfName.toString());
        }
	return res;
    }

    private static List<String> getNomCapitales(List<String> uris) {
	List<String> res = new ArrayList<String>();
	for(String uri : uris)
	    res.add(getNomCapitaleOuPays(uri));
	return res;
    }

    private static String[] getQuestions(String _uriPays) {
	String[] res = new String[4];
	List<String> autres = getURIAutresCapitales(_uriPays);
	autres = choisirCapitales(autres,3);
	res[0] = getNomCapitaleOuPays(getURICapitale(_uriPays));
	for(int i=0;i<autres.size();i++)
	    res[1+i] = getNomCapitaleOuPays(autres.get(i));
	return res;
    }

    public QuestionReponsesCapitales(String _uriPays) {
	super(getQuestions(_uriPays),0);
	uriPays = _uriPays;
    }

    public String getDomaine() {
	return "Géographie (Wikidata)";
    }
    public String getQuestion() {
	return "Quelle est la capiltale du (de la) "+getNomCapitaleOuPays(uriPays);
    }
}
