package fr.insarouen.asi.document.quizz.webSemantique.Wikidata;

import fr.insarouen.asi.document.quizz.QuestionReponses;
import fr.insarouen.asi.document.quizz.QuestionReponsesFactory;
import java.util.Random;
import java.util.List;
import java.util.ArrayList;
import org.apache.jena.query.QuerySolution;
import org.apache.jena.rdf.model.RDFNode;
import fr.insarouen.asi.document.quizz.webSemantique.Outils;
import fr.insarouen.asi.document.quizz.webSemantique.QuestionReponsesWebSemantique;

public class QuestionReponsesCapitalesFactory implements QuestionReponsesFactory {

    static private Random generateur = new Random();

    private List<String> getURIPays() {
	List<String> res = new ArrayList<String>();
	RDFNode rdfName;
	String request = "select ?uri where{\n"
	    + "?uri wdt:P31 wd:Q6256."
	    + "?uri wdt:P36 ?cap."
	    + "}";
        for (QuerySolution solution : Outils.SPARQLQuerySolutions(QuestionReponsesWikidata.getEntreeSparql(),
								  QuestionReponsesWikidata.getPrefixSparql(), request)) {
            rdfName = solution.get("uri");
            res.add(rdfName.toString());
        }
	return res;
    }

    public QuestionReponses getQuestionReponses() {
	List<String> ls = getURIPays();
	int pos = generateur.nextInt(ls.size());
	return new QuestionReponsesCapitales(ls.get(pos));
    }
}
